package shadersmod.transform;

import java.util.Iterator;

import org.objectweb.asm.ClassReader;
import org.objectweb.asm.ClassVisitor;
import org.objectweb.asm.ClassWriter;
import org.objectweb.asm.FieldVisitor;
import org.objectweb.asm.Label;
import org.objectweb.asm.MethodVisitor;
import org.objectweb.asm.Opcodes;
import static org.objectweb.asm.Opcodes.*;

import org.objectweb.asm.commons.Remapper;
import org.objectweb.asm.tree.MethodNode;

import shadersmod.common.SMCLog;
import net.minecraft.launchwrapper.IClassTransformer;

// for ChunkRenderDispatcher

public class STChunkRenderDispatcher implements IClassTransformer {

	@Override
	public byte[] transform(String par1, String par2, byte[] par3) {
		SMCLog.fine("transforming %s %s",par1,par2);
		ClassReader cr = new ClassReader(par3);
		ClassWriter cw = new ClassWriter(cr, 0);
		CVTransform cv = new CVTransform(cw);
		cr.accept(cv,0);
		return cw.toByteArray();
	}

	private static class CVTransform extends ClassVisitor
	{
		String classname;
		boolean endFields = false;
		
		public CVTransform(ClassVisitor cv)
		{
			super(Opcodes.ASM4, cv);		
		}

		@Override
		public void visit(int version, int access, String name,
				String signature, String superName, String[] interfaces) {
			classname = name;
			//SMCLog.info(" class %s",name);
			cv.visit(version, access, name, signature, superName, interfaces);
		}

		@Override
		public MethodVisitor visitMethod(int access, String name, String desc,
				String signature, String[] exceptions) {
			if (Names.chunkRenderDispatcher_init.equalsNameDesc(name,desc)) {
				return new MVinit(cv.visitMethod(access, name, desc, signature, exceptions));
			}
			return cv.visitMethod(access, name, desc, signature, exceptions);
		}
	}

	private static class MVinit extends MethodVisitor
	{
		public MVinit(MethodVisitor mv) {
			super(Opcodes.ASM4, mv);
		}
		
		@Override
		public void visitTypeInsn(int opcode, String type) {
			if (opcode==NEW) {
				if (Names.vertexBufferDrawer_.name.equals(type)) {
					mv.visitTypeInsn(opcode, Names.sVertexBufferDrawerChunk_.name);
					return;
				}
			}
			mv.visitTypeInsn(opcode, type);
		}

		@Override
		public void visitMethodInsn(int opcode, String owner, String name, String desc) {
			if (Names.vertexBufferDrawer_init.equals(owner, name, desc)) {
				mv.visitMethodInsn(opcode, Names.sVertexBufferDrawerChunk_init.clasName, Names.sVertexBufferDrawerChunk_init.name, Names.sVertexBufferDrawerChunk_init.desc);
				return;
			}
			mv.visitMethodInsn(opcode, owner, name, desc);
		}
	}
}
